/********************************************************************
 ***       Beispielprogramm in C zur Relaiskarte RL1335           ***
 ********************************************************************/
#include <stdio.h>
#include <conio.h>
void clear_screen(void);

unsigned int adresse=0x100;	       /* Adresse der Relaiskarte   */
unsigned char Relaiszustand=0;         /* Zwischenspeicher
					  fr Relaiszustnde        */
int key=0;                             /* Variable fr Tastencode   */
int cx=0;                              /* Eingabecursorposition     */
int i;				       /* Laufvariable              */

void main(void)
{
  /* Bildschirm initialisieren */
  clear_screen();                       /* Bildschirm lschen           */
  _setcursortype(_NOCURSOR);		/* DOS-Cursor ausschalten       */

  /* Tasten auswerten */
  key=0;                                /* Variable fr Taste initialisieren */
  do                                    /* in Schleife verharren        */
    {                                   /* bis Taste           gedrckt */
      if(kbhit())                       /* Ist Taste gedrckt ?         */
	{                               /* Wenn ja, dann                */
	  key=getch();                  /* ASCII-Wert lesen             */
	  if(key==0)
	    {
	      /* Funktionstaste -> Scan-Code auswerten */
	      key=getch();              /* Scan-Code holen              */
		switch (key)
		  {
		    case 77 :
		      {
			/* Cursor rechts */
			if(cx>0)
			  cx--;
			else
			  /* Cursor am rechten Tabellenende */
			  printf("\a");
			break;
		      }
		    case 75 :
		      {
			/* Cursor links */
			if(cx<7)
			  cx++;
			else
			  /* Cursor am linken Tabellenende */
			  printf("\a");
			break;
		      }
		  }
	    }
	  else
	    {
	      /* Einfache Zeichentaste wurde bettigt */
		switch(key)
		  {
		    case 13 :    /* Taste Return/Enter */
		    case 32 :    /* Taste Space */
		      {
			/* Ausgabebit invertieren auf der der Cursor steht*/
			Relaiszustand=Relaiszustand ^ (1 << cx);
			/* An Karte ausgeben */
			  outportb(adresse,Relaiszustand);
			break;
		      }
		  }
	    }
	}
      /* Werte auf dem Bildschirm in der Tabelle darstellen */
	for(i=0;i<8;i++)               /* alle 8 Bit */
	  {
	    if(cx==i)
	      {
		if((Relaiszustand & (1 << i))==0)
		  {
		    textattr(0x2A);    /* Darstellung Cursoreintrag 0 */
		    gotoxy(59-(4*i),12);
		    cprintf(" 0 ");
		  }
		else
		  {
		    textattr(0x6C);    /* Darstellung Cursoreintrag 1 */
		    gotoxy(59-(4*i),12);
		    cprintf(" 1 ");
		}
	      }
	    else
	      {
		if((Relaiszustand & (1 << i))==0)
		  {
		    textattr(0x7E);    /* Darstellung normaler Eintrag 0 */
		    gotoxy(59-(4*i),12);
		    cprintf(" 0 ");
		  }
		else
		  {
		    textattr(0x34);    /* Darstellung normaler Eintrag 1 */
		    gotoxy(59-(4*i),12);
		    cprintf(" 1 ");
		  }
	      }
	  }
    }
  while (key!=68);                      /* Wenn F10, dann ende          */
  textattr(0x07);	                /* Standardfarben wieder an     */
  clrscr();			        /* Bildschirm lschen           */
  outportb(adresse,0);		        /* Relais ausschalten           */
  _setcursortype(_NORMALCURSOR);        /* Standardcursor an            */
}
/************************************************************************
 ***                Unterprogramme zur Bildschirmsteuerung            ***
 ************************************************************************/

void clear_screen(void)
{
  /* Diese Funktion dient zum lschen des Bildschirmes, sowie dessen
	  Einstellung. Der Hintergrund wird auf die Farbe Blau eingestellt.
	  Es wird des weiteren ein Fenster mit der Firmenadresse dargestellt.  */

  /* Fenster 1 */
  char rahm1[]="ͻ";
  char rahm2[]="                                                         ";
  char rahm3[]="ͼ";
  char text1[]=" ERMA-Electronic GmbH, Max-Eyth-Str. 8, 78194 Immendingen";
  char text2[]="      Tel. 07462/7381               Fax 07462/7554       ";
  char text3[]="";

  /* Fenster 2 */
  char rahm21[]="ͻ";
  char rahm22[]="                                               ";
  char rahm23[]=" F10 = ENDE ͼ";
  char rahm24[]="";
  char zeile1[]="Ŀ";
  char zeile2[]="";
  char text20[]="   Relais   8   7   6   5   4   3   2   1";
  char text21[]=" Zustand                         ";
  char text22[]="1 bedeutet: Relais AN,";
  char text23[]="0 bedeutet: Relais AUS";
  char text24[]="Leertaste = Relais umschalten AN/AUS";
  char text25[]="Cursor rechts/links = Relais auswhlen";

  char x,f1x=12,f2x=17;

  textbackground(BLUE);                 /* Hintergrundfarbe schwarz     */
  textcolor(CYAN);                      /* Vordergrundfarbe hellgrau    */
  clrscr();                             /* Bildschirm lschen           */

  /* Erzeugen eines Fensters */
  gotoxy(f1x,2);
  textattr(0x7F);
  cprintf(rahm1);
  gotoxy(f1x,3);
  cprintf(rahm2);
  gotoxy(f1x,4);
  cprintf(rahm2);
  gotoxy(f1x,5);
  cprintf(rahm3);
  /* Erzeugen des Fenstertextes */
  textattr(0x70);
  gotoxy(f1x+1,3);
  cprintf(text1);
  gotoxy(f1x+1,4);
  cprintf(text2);
  /* Erzeugen des Fensterschattens */
  gotoxy(f1x+1,6);
  cprintf(text3);
  gotoxy(71,3);
  cprintf("");
  gotoxy(71,4);
  cprintf("");
  gotoxy(71,5);
  cprintf("");
  textattr(0x03);

  /* Erzeugen des Ausgabefensters */
  gotoxy(f2x,8);
  textattr(0x7F);
  cprintf(rahm21);
  for(x=9;x<20;x++)
    {
      gotoxy(f2x,x);
      cprintf(rahm22);
    }
  gotoxy(f2x,x++);
  cprintf(rahm23);
  /* Erzeugen des Fensterschattens */
  textattr(0x70);
  gotoxy(f2x+1,x++);
  cprintf(rahm24);
  for(x=9;x<20;x++)
    {
      gotoxy(f2x+49,x);
      cprintf("");
    }
  gotoxy(f2x+49,x++);
  cprintf("");
  textattr(0x03);
  /* Erzeugen des Fenstertextes */
  textattr(0x70);
  gotoxy(f2x+3,10);
  cprintf(text20);
  gotoxy(f2x+3,11);
  cprintf(zeile1);
  gotoxy(f2x+3,12);
  cprintf(text21);
  gotoxy(f2x+3,13);
  cprintf(zeile2);
  gotoxy(f2x+15,15);
  cprintf(text22);
  gotoxy(f2x+15,16);
  cprintf(text23);
  gotoxy(f2x+7,17);
  cprintf(text24);
  gotoxy(f2x+6,18);
  cprintf(text25);
}

