program RL1335;
{********************************************************************
 *** Beispielprogramm in Turbo Pascal zur Relaiskarte RL1335      ***
 ********************************************************************}
uses DOS, CRT;
const
  adresse:Integer  =  $100;            { Adresse der Relaiskarte     }

var
  Relaiszustand    :  Byte;            { Zwischenspeicher
				         fr Relaiszustnde         }
  key              :  Char;            { Variable fr Tastencode    }
  cx               :  Byte;            { Eingabecursorposition      }
  i                :  Byte;	       { Laufvariable               }

  {******************************************************************
   ***             Unterprogramme zur Bildschirmsteuerung         ***
   ******************************************************************}

  procedure clear_screen;
    { Diese Funktion dient zum lschen des Bildschirmes, sowie dessen
      Einstellung. Der Hintergrund wird auf die Farbe Blau eingestellt.
      Es wird des weiteren ein Fenster mit der Firmenadresse dargestellt.}
  const
    { Fenster 1 }
    rahm1='ͻ';
    rahm2='                                                         ';
    rahm3='ͼ';
    text1=' ERMA-Electronic GmbH, Max-Eyth-Str. 8, 78194 Immendingen';
    text2='      Tel. 07462/7381               Fax 07462/7554       ';
    text3='';

    { Fenster 2 }
    rahm21='ͻ';
    rahm22='                                               ';
    rahm23=' F10 = ENDE ͼ';
    rahm24='';
    zeile1='Ŀ';
    zeile2='';
    text20='   Relais   8   7   6   5   4   3   2   1';
    text21=' Zustand                         ';
    text22='1 bedeutet: Relais AN,';
    text23='0 bedeutet: Relais AUS';
    text24='Leertaste = Relais umschalten AN/AUS';
    text25='Cursor rechts/links = Relais auswhlen';
    f1x=12;
    f2x=17;
  var
    x      : Integer;
  begin
    TextBackGround(BLUE);                 { Hintergrundfarbe schwarz      }
    TextColor(CYAN);                      { Vordergrundfarbe hellgrau     }
    ClrScr;                               { Bildschirm lschen            }

    { Erzeugen eines Fensters }
    GotoXY(f1x,2);
    TextAttr:=$7F;
    Write(rahm1);
    GotoXY(f1x,3);
    Write(rahm2);
    GotoXY(f1x,4);
    Write(rahm2);
    GotoXY(f1x,5);
    Write(rahm3);
    { Erzeugen des Fenstertextes }
    TextAttr:=$70;
    GotoXY(f1x+1,3);
    Write(text1);
    GotoXY(f1x+1,4);
    Write(text2);
    { Erzeugen des Fensterschattens }
    GotoXY(f1x+1,6);
    Write(text3);
    GotoXY(71,3);
    Write('');
    GotoXY(71,4);
    Write('');
    GotoXY(71,5);
    Write('');

    { Erzeugen des Ausgabefensters }
    GotoXY(f2x,8);
    TextAttr:=$7F;
    Write(rahm21);
    for x:=9 to 20 do
      begin
        GotoXY(f2x,x);
        Write(rahm22);
      end;
    GotoXY(f2x,x+1);
    Write(rahm23);
    { Erzeugen des Fensterschattens }
    TextAttr:=$70;
    GotoXY(f2x+1,x+2);
    Write(rahm24);
    for x:=9 to 20 do
      begin
        GotoXY(f2x+49,x);
        Write('');
      end;
    GotoXY(f2x+49,x+1);
    Write('');
    { Erzeugen des Fenstertextes }
    TextAttr:=$70;
    GotoXY(f2x+3,10);
    Write(text20);
    GotoXY(f2x+3,11);
    Write(zeile1);
    GotoXY(f2x+3,12);
    Write(text21);
    GotoXY(f2x+3,13);
    Write(zeile2);
    GotoXY(f2x+15,15);
    Write(text22);
    GotoXY(f2x+15,16);
    Write(text23);
    GotoXY(f2x+7,17);
    Write(text24);
    GotoXY(f2x+6,18);
    Write(text25);
  end;
  {****************************************************************************
   *** Funktion zur An- und Abschaltung des Cursors                         ***
   *** bergabeparameter: sichtbar = false => Cursor wird abgeschaltet      ***
   ***                    sichtbar = true  => Cursor wird angeschaltet      ***
   ****************************************************************************}
  procedure cursor(sichtbar: boolean);
  var
    reg 	  : registers;
    schirmanfang  : longint;

  begin
    reg.ah:=1;
    if sichtbar then begin
      if schirmanfang=$b800 then begin
        reg.ch:=6;
       	reg.cl:=7;
        end
      else begin
        reg.ch:=12;
       	reg.cl:=13;
      	end;
      INTR(16,reg);
      end
    else begin
      reg.ch:=32;
      reg.cl:=7;
      INTR(16,reg);
      end;
  end;


begin
  cx:=0;                               { Cursorposition setzen       }
  Relaiszustand:=0;                    { Zwischenspeicher setzen     }
  Port[adresse]:=0;                    { Relais rcksetzen           }
  { Bildschirm initialisieren }
  clear_screen;                        { Bildschirm lschen          }
  cursor(False);             	       { DOS-Cursor ausschalten      }

  { Tasten auswerten }
  key:=Chr(0);                         { Variable fr Taste initialisieren}
  repeat                               { in Schleife verharren       }
                                       { bis Taste gedrckt          }
      if keypressed then               { Ist Taste gedrckt ?        }
	begin                          { Wenn ja, dann               }
	  key:=ReadKey;                { ASCII-Wert lesen            }
	  if key=Chr(0) then
	    begin
	      { Funktionstaste -> Scan-Code auswerten }
	      key:=ReadKey;            { Scan-Code holen             }
	      case key of
		Chr(77) : begin
			  { Cursor rechts }
			  if cx>0 then
			    Dec(cx)
			  else
			    { Cursor am rechten Tabellenende }
			    begin
                            Sound(1000);
                            Delay(100);
                            NoSound;
                            end;
		          end;
		Chr(75) : begin
			  { Cursor links }
			  if cx<7 then
			    Inc(cx)
                          else
			    { Cursor am linken Tabellenende }
                            begin
                            Sound(1000);
                            Delay(100);
                            NoSound;
                            end;
		          end;
	      end;
	    end
	  else
	    begin
	    { Einfache Zeichentaste wurde bettigt }
	    case key of
	      Chr(13),                 { Taste Return/Enter }
	      Chr(32) :                { Taste Space        }
		        begin
			{ Ausgabebit invertieren auf der der Cursor steht }
			Relaiszustand:=Relaiszustand xor (1 SHL cx);
			{ An Karte ausgeben }
			Port[adresse]:=Relaiszustand;
                        end;
	      end;
	    end;
	end;
      { Werte auf dem Bildschirm in der Tabelle darstellen }
      for i:=0 to 7 do                 { alle 8 Bit }
	begin
          GotoXY(59-(4*i),12);
	  if cx=i then
	    begin
	      if (Relaiszustand and (1 SHL i))=0 then
		begin
		  TextAttr:=$2A;       { Darstellung Cursoreintrag 0 }
		  Write(' 0 ');
		end
	      else
		begin
		  TextAttr:=$6C;       { Darstellung Cursoreintrag 1 }
		  Write(' 1 ');
		end;
	    end
	  else
	    begin
	      if (Relaiszustand and (1 SHL i))=0 then
		begin
		  TextAttr:=$7E;     { Darstellung normaler Eintrag 0 }
		  Write(' 0 ');
		end
	      else
		begin
		  TextAttr:=$34;     { Darstellung normaler Eintrag 1 }
		  Write(' 1 ');
		end;
	    end;
	  end;

  until key=Chr(68);                   { Wenn F10, dann ende          }
  TextAttr:=$07;	               { Standardfarben wieder an     }
  ClrScr;			       { Bildschirm lschen           }
  Port[adresse]:=0;		       { Relais ausschalten           }
  cursor(True);                        { Standardcursor an            }
end.

