DECLARE SUB clearscreen ()
REM ********************************************************************
REM *** Beispielprogramm in Turbo Pascal zur Relaiskarte RL1335      ***
REM ********************************************************************
adresse = &H100:                       REM Adresse der Relaiskarte
cx = 0:                                REM Cursorposition setzen
Relaiszustand = 0:                     REM Zwischenspeicher setzen
OUT adresse, 0:                        REM Relais rcksetzen
REM Bildschirm initialisieren
clearscreen
REM DOS-Cursor ausschalten

REM Tasten auswerten
DO:                                    REM in Schleife verharren
				       REM bis Taste gedrckt
  Taste$ = INKEY$
  IF LEN(Taste$) <> 0 THEN
    IF LEFT$(Taste$, 1) = CHR$(0) THEN
    REM Funktionstaste -> Scan-Code auswerten
      IF RIGHT$(Taste$, 1) = CHR$(77) THEN
	 REM Cursor rechts
	 IF cx > 0 THEN
	   cx = cx - 1
	 ELSE
	   REM Cursor am rechten Tabellenende
	   BEEP
	 END IF
      END IF
      IF RIGHT$(Taste$, 1) = CHR$(75) THEN
	REM Cursor links
	IF cx < 7 THEN
	  cx = cx + 1
	ELSE
	  REM Cursor am linken Tabellenende
	  BEEP
	END IF
      END IF
    ELSE
      REM Einfache Zeichentaste wurde bettigt
      REM Return/Enter/Space
      IF (LEFT$(Taste$, 1) = CHR$(13)) OR (LEFT$(Taste$, 1) = CHR$(32)) THEN
	REM Ausgabebit invertieren auf der der Cursor steht
	Relaiszustand = Relaiszustand XOR (2 ^ cx)
	REM An Karte ausgeben
	OUT adresse, Relaiszustand
      END IF
    END IF
  END IF
  REM Werte auf dem Bildschirm in der Tabelle darstellen
  FOR i = 0 TO 7:                      REM alle 8 Bit
    LOCATE 12, 59 - (4 * i)
    IF cx = i THEN
      IF (Relaiszustand AND (2 ^ i)) = 0 THEN
	COLOR &HA, 2:                  REM Darstellung Cursoreintrag 0
	PRINT " 0 "
      ELSE
	COLOR &HC, 6:                  REM Darstellung Cursoreintrag 1
	PRINT " 1 "
      END IF
    ELSE
      IF (Relaiszustand AND (2 ^ i)) = 0 THEN
	COLOR &HE, 7:                  REM Darstellung normaler Eintrag 0
	PRINT " 0 "
      ELSE
	COLOR 4, 3:                    REM Darstellung normaler Eintrag 1
	PRINT " 1 "
      END IF
    END IF
  NEXT i
  LOOP UNTIL RIGHT$(Taste$, 1) = CHR$(68): REM Wenn F10, dann ende
  COLOR 7, 0:                          REM Standardfarben wieder an
  CLS :                                REM Bildschirm lschen
  OUT adresse, 0:                      REM Relais ausschalten
  REM cursor(True);                        { Standardcursor an            }
END

  SUB clearscreen
  REM ******************************************************************
  REM ***             Unterprogramme zur Bildschirmsteuerung         ***
  REM ******************************************************************
  REM Fenster 1
  rahm1$ = "ͻ"
  rahm2$ = "                                                         "
  rahm3$ = "ͼ"
  text1$ = " ERMA-Electronic GmbH, Max-Eyth-Str. 8, 78194 Immendingen"
  text2$ = "      Tel. 07462/7381               Fax 07462/7554       "
  text3$ = ""

  REM Fenster 2
  rahm21$ = "ͻ"
  rahm22$ = "                                               "
  rahm23$ = " F10 = ENDE ͼ"
  rahm24$ = ""
  zeile1$ = "Ŀ"
  zeile2$ = ""
  text20$ = "   Relais   8   7   6   5   4   3   2   1"
  text21$ = " Zustand                         "
  text22$ = "1 bedeutet: Relais AN,"
  text23$ = "0 bedeutet: Relais AUS"
  text24$ = "Leertaste = Relais umschalten AN/AUS"
  text25$ = "Cursor rechts/links = Relais auswhlen"
  f1x = 12
  f2x = 17
  COLOR 2, 1:                         REM Hintergrundfarbe schwarz
  CLS :                               REM Bildschirm lschen

  REM Erzeugen eines Fensters
  LOCATE 2, f1x
  COLOR &HF, 7
  PRINT rahm1$
  LOCATE 3, f1x
  PRINT rahm2$
  LOCATE 4, f1x
  PRINT rahm2$
  LOCATE 5, f1x
  PRINT rahm3$
  REM Erzeugen des Fenstertextes
  COLOR 0, 7
  LOCATE 3, f1x + 1
  PRINT text1$
  LOCATE 4, f1x + 1
  PRINT text2$
  REM Erzeugen des Fensterschattens
  LOCATE 6, f1x + 1
  PRINT text3$
  LOCATE 3, 71
  PRINT ""
  LOCATE 4, 71
  PRINT ""
  LOCATE 5, 71
  PRINT ""

  REM Erzeugen des Ausgabefensters
  LOCATE 8, f2x
  COLOR &HF, 7
  PRINT rahm21$
  FOR x = 9 TO 20
    LOCATE x, f2x
    PRINT rahm22$
  NEXT x
  LOCATE x, f2x
  PRINT rahm23$
  REM Erzeugen des Fensterschattens
  COLOR 0, 7
  LOCATE x + 1, f2x + 1
  PRINT rahm24$
  FOR x = 9 TO 20
    LOCATE x, f2x + 49
    PRINT ""
  NEXT x
  LOCATE x, f2x + 49
  PRINT ""
  REM Erzeugen des Fenstertextes
  COLOR 0, 7
  LOCATE 10, f2x + 3
  PRINT text20$
  LOCATE 11, f2x + 3
  PRINT zeile1$
  LOCATE 12, f2x + 3
  PRINT text21$
  LOCATE 13, f2x + 3
  PRINT zeile2$
  LOCATE 15, f2x + 15
  PRINT text22$
  LOCATE 16, f2x + 15
  PRINT text23$
  LOCATE 17, f2x + 7
  PRINT text24$
  LOCATE 18, f2x + 6
  PRINT text25$

END SUB

